/*
 * Dez threads foram criadas. Qual receberá o sinal?
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <signal.h>

#define N_THR 10

void trata_SIGUSR1(int sig) {
  printf("Tratando SIGUSR1.\n");
}

void* f_thread(void *v) {
  int thr_id = *(int *) v; 
  sleep(3);
  printf("Thread %d.\n", thr_id);  
  return NULL; 
} 

int main() {
  pthread_t thr[N_THR];
  int i, id[N_THR];

  signal(SIGUSR1, trata_SIGUSR1);

  if (fork() == 0) {
    sleep(1);
    kill(getppid(),SIGUSR1);
  }
  else {
    for (i = 0; i < N_THR; i++) {
      id[i] = i;
      pthread_create(&thr[i], NULL, f_thread, (void*) &id[i]);
    }

    for (i = 0; i < N_THR; i++) 
      pthread_join(thr[i], NULL); 
  }
  return 0;
}
