/*
 * O sinal fica bloqueado para todas as threads?
 * Como desbloquear para uma delas?
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <signal.h>

#define N_THR 10

void trata_SIGTERM(int signum) {
  printf("Adeus mundo cruel!\n"); 
  signal(SIGTERM, SIG_DFL);
  raise(SIGTERM); 
}

void* f_thread(void *v) {
  int thr_id = *(int *) v; 
  sigset_t block_sigterm;
  sigaddset (&block_sigterm, SIGTERM);
  pthread_sigmask (SIG_BLOCK, &block_sigterm, NULL);
  sleep(3);
  printf("Thread %d.\n", thr_id);  
  return NULL; 
} 

int main() {
  pthread_t thr[N_THR];
  int i, id[N_THR];

 signal(SIGTERM, trata_SIGTERM);

  if (fork() == 0) {
    sleep(1);
    kill(getppid(),SIGTERM);
  }
  else {
    sigset_t block_sigterm;

    for (i = 0; i < N_THR; i++) {
      id[i] = i;
      pthread_create(&thr[i], NULL, f_thread, (void*) &id[i]);
    }

    sigaddset (&block_sigterm, SIGTERM);
    pthread_sigmask (SIG_BLOCK, &block_sigterm, NULL);

    for (i = 0; i < N_THR; i++) 
      pthread_join(thr[i], NULL); 
  }
  return 0;
}
